import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo-core.css';
import './styles.css';
import { FlexGrid, ColumnGroup, ColumnGroupCollection } from '@mescius/wijmo.grid';
import { toggleClass } from '@mescius/wijmo';
import * as DataService from './data';
document.readyState === 'complete' ? init() : window.onload = init;
function init() {
let theGrid = new FlexGrid('#theGrid', {
headersVisibility: 'Column',
alternatingRowStep: 0,
showMarquee: true,
showSelectedHeaders: 'All',
autoGenerateColumns: false,
columnGroups: new ColumnGroupCollection([
new ColumnGroup({ binding: 'name', header: 'Name', width: 150 }),
new ColumnGroup({ binding: 'currency', header: 'Curr', width: 80, align: 'center' }),
new ColumnGroup({ header: 'Allocation', align: 'center', collapseTo: 'alloc.amount', columns: new ColumnGroupCollection([
new ColumnGroup({ binding: 'alloc.stock', header: 'Stocks', format: 'p0', width: 80 }),
new ColumnGroup({ binding: 'alloc.bond', header: 'Bonds', format: 'p0', width: 80 }),
new ColumnGroup({ header: 'Detail', align: 'center', columns: new ColumnGroupCollection([
new ColumnGroup({ binding: 'alloc.cash', header: 'Cash', format: 'p0', width: 80 }),
new ColumnGroup({ binding: 'alloc.other', header: 'Other', format: 'p0', width: 80 }),
]) }),
new ColumnGroup({ binding: 'alloc.amount', header: 'Amount', format: 'c0', width: 100, cssClass: 'main-column' }),
]) }),
new ColumnGroup({ header: 'Perf', align: 'center', columns: new ColumnGroupCollection([
new ColumnGroup({ header: 'Short', align: 'center', collapseTo: 'perf.ytd', isCollapsed: true, columns: new ColumnGroupCollection([
new ColumnGroup({ binding: 'perf.ytd', header: 'YTD', format: 'p2', width: 100, cssClass: 'main-column' }),
new ColumnGroup({ binding: 'perf.m1', header: '1 M', format: 'p2', width: 80 }),
]) }),
new ColumnGroup({ header: 'Long', align: 'center', collapseTo: 'perf.m12', isCollapsed: true, columns: new ColumnGroupCollection([
new ColumnGroup({ binding: 'perf.m6', header: '6 M', format: 'p2', width: 80 }),
new ColumnGroup({ binding: 'perf.m12', header: '12 M', format: 'p2', width: 100, cssClassAll: 'main-column' }),
]) }),
]) }),
]),
itemsSource: DataService.getData(),
});
// init collapse/expand animation checkbox
const setAnimation = (animated) => {
toggleClass(theGrid.hostElement, 'animated', animated);
};
const animChk = document.getElementById('animated');
animChk.addEventListener('click', e => setAnimation(e.target.checked));
animChk.checked = true;
setAnimation(animChk.checked);
// init use cell templates checkbox
const setUseTemplates = (useTemplates) => {
const cellTemplate = useTemplates
? cell => {
const grid = cell.row.grid;
const rowIdx = cell.row.index;
const colIdx = cell.col.index;
const cssClass = grid.getCellData(rowIdx, colIdx, false) > .2 ? 'big-val' : 'small-val';
const value = grid.getCellData(rowIdx, colIdx, true);
return `<span class="${cssClass}">${value}</span>`;
}
: null;
theGrid.getColumn('alloc.stock').cellTemplate = cellTemplate;
theGrid.getColumn('alloc.bond').cellTemplate = cellTemplate;
theGrid.getColumn('alloc.cash').cellTemplate = cellTemplate;
theGrid.getColumn('alloc.other').cellTemplate = cellTemplate;
};
const tplChk = document.getElementById('templates');
tplChk.addEventListener('click', e => setUseTemplates(e.target.checked));
tplChk.checked = true;
setUseTemplates(tplChk.checked);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Column Groups with Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<main class="container-fluid">
<label>
Collapse/Expand Animation
<input id="animated" type="checkbox" />
</label>
<label>
Use cell templates
<input id="templates" type="checkbox" />
</label>
<div id="theGrid" />
</main>
</body>
</html>
// get some sample data
export function getData() {
return [{
name: 'Constant Growth',
currency: 'USD',
perf: {
ytd: .0523,
m1: 0.0142,
m6: 0.0443,
m12: 0.0743
},
alloc: {
stock: 0.17,
bond: 0.32,
cash: 0.36,
other: 0.15,
amount: 23432
}
}, {
name: 'Optimus Prime',
currency: 'EUR',
perf: {
ytd: .0343,
m1: 0.043,
m6: 0.0244,
m12: 0.0543
},
alloc: {
stock: 0.61,
bond: 0.8,
cash: 0.9,
other: 0.22,
amount: 43223
}
}, {
name: 'Crypto Planet',
currency: 'BTC',
perf: {
ytd: .0343,
m1: 0.014,
m6: 0.034,
m12: 0.01243
},
alloc: {
stock: 0.1,
bond: 0,
cash: 0,
other: 0.9,
amount: 2234
}
}, {
name: 'MegaZone',
currency: 'EUR',
perf: {
ytd: .0443,
m1: 0.034,
m6: 0.0424,
m12: 0.0343
},
alloc: {
stock: 0.51,
bond: 0.9,
cash: 0.8,
other: 0.12,
amount: 32234
}
}, {
name: 'Serenity',
currency: 'YEN',
perf: {
ytd: .0522,
m1: 0.0143,
m6: 0.0458,
m12: 0.0732
},
alloc: {
stock: 0.66,
bond: 0.09,
cash: 0.19,
other: 0.06,
amount: 65624
}
}];
}
label {
display: block;
}
.wj-flexgrid {
margin: 10px 0;
}
/* highlight the main column in the group */
.wj-flexgrid .wj-cells .wj-cell.main-column {
background: #e3f4ff;
}
/* some conditional formatting */
.big-val {
font-weight: bold;
color: darkgreen;
}
.small-val {
font-style: italic;
color: rgb(202, 0, 0);
}
/* some animation when collapsing/expanding the groups */
.wj-flexgrid.animated .wj-colheaders .wj-header.wj-cell.wj-colgroup {
transition: all .2s;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import * as DataService from './app.data';
@Component({
standalone: true,
imports: [WjGridModule, BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
animated = true;
useCellTemplates = true;
data = DataService.getData();
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Column Groups with Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<label>
Collapse/Expand Animation
<input id="animated" type="checkbox" [(ngModel)]="animated"/>
</label>
<label>
Use cell templates
<input type="checkbox" [(ngModel)]="useCellTemplates"/>
</label>
<wj-flex-grid #grid [class.animated]="animated"
headersVisibility="Column"
showSelectedHeaders="All"
[alternatingRowStep]="0"
[showMarquee]="true"
[autoGenerateColumns]="false"
[itemsSource]="data">
<wj-flex-grid-column-group binding="name" header="Name" [width]="150" ></wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="currency" header="Curr" [width]="80" align="center" ></wj-flex-grid-column-group>
<wj-flex-grid-column-group #allocGr header="Allocation" align="center" collapseTo="alloc.amount">
<wj-flex-grid-column-group binding="alloc.stock" header="Stocks" format="p0" [width]="80" >
@if (useCellTemplates) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span [class.big-val]="grid.getCellData(cell.row.index, cell.col.index, false) > .2" [class.small-val]="grid.getCellData(cell.row.index, cell.col.index, false) <= .2">
{{grid.getCellData(cell.row.index, cell.col.index, true)}}
</span>
</ng-template>
}
</wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="alloc.bond" header="Bonds" format="p0" [width]="80" >
@if (useCellTemplates) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span [class.big-val]="grid.getCellData(cell.row.index, cell.col.index, false) > .2" [class.small-val]="grid.getCellData(cell.row.index, cell.col.index, false) <= .2">
{{grid.getCellData(cell.row.index, cell.col.index, true)}}
</span>
</ng-template>
}
</wj-flex-grid-column-group>
<wj-flex-grid-column-group header="Detail" align="center" >
<wj-flex-grid-column-group binding="alloc.cash" header="Cash" format="p0" [width]="80" >
@if (useCellTemplates) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span [class.big-val]="grid.getCellData(cell.row.index, cell.col.index, false) > .2" [class.small-val]="grid.getCellData(cell.row.index, cell.col.index, false) <= .2">
{{grid.getCellData(cell.row.index, cell.col.index, true)}}
</span>
</ng-template>
}
</wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="alloc.other" header="Other" format="p0" [width]="80" >
@if (useCellTemplates) {
<ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
<span [class.big-val]="grid.getCellData(cell.row.index, cell.col.index, false) > .2" [class.small-val]="grid.getCellData(cell.row.index, cell.col.index, false) <= .2">
{{grid.getCellData(cell.row.index, cell.col.index, true)}}
</span>
</ng-template>
}
</wj-flex-grid-column-group>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="alloc.amount" header="Amount" format="c0" [width]="100" cssClass="main-column" ></wj-flex-grid-column-group>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group header="Perf" align="center" >
<wj-flex-grid-column-group header="Short" align="center" collapseTo="perf.ytd" [isCollapsed]="true" >
<wj-flex-grid-column-group binding="perf.ytd" header="YTD" format="p2" [width]="100" cssClass="main-column" ></wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="perf.m1" header="1 M" format="p2" [width]="80" ></wj-flex-grid-column-group>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group header="Long" align="center" collapseTo="perf.m12" [isCollapsed]="true" >
<wj-flex-grid-column-group binding="perf.m6" header="6 M" format="p2" [width]="80" ></wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="perf.m12" header="12 M" format="p2" [width]="100" cssClass="main-column" ></wj-flex-grid-column-group>
</wj-flex-grid-column-group>
</wj-flex-grid-column-group>
</wj-flex-grid>
</main>
// get some sample data
export function getData(): any[] {
return [{
name: 'Constant Growth',
currency: 'USD',
perf: {
ytd: .0523,
m1: 0.0142,
m6: 0.0443,
m12: 0.0743
},
alloc: {
stock: 0.17,
bond: 0.32,
cash: 0.36,
other: 0.15,
amount: 23432
}
}, {
name: 'Optimus Prime',
currency: 'EUR',
perf: {
ytd: .0343,
m1: 0.043,
m6: 0.0244,
m12: 0.0543
},
alloc: {
stock: 0.61,
bond: 0.8,
cash: 0.9,
other: 0.22,
amount: 43223
}
}, {
name: 'Crypto Planet',
currency: 'BTC',
perf: {
ytd: .0343,
m1: 0.014,
m6: 0.034,
m12: 0.01243
},
alloc: {
stock: 0.1,
bond: 0,
cash: 0,
other: 0.9,
amount: 2234
}
}, {
name: 'MegaZone',
currency: 'EUR',
perf: {
ytd: .0443,
m1: 0.034,
m6: 0.0424,
m12: 0.0343
},
alloc: {
stock: 0.51,
bond: 0.9,
cash: 0.8,
other: 0.12,
amount: 32234
}
}, {
name: 'Serenity',
currency: 'YEN',
perf: {
ytd: .0522,
m1: 0.0143,
m6: 0.0458,
m12: 0.0732
},
alloc: {
stock: 0.66,
bond: 0.09,
cash: 0.19,
other: 0.06,
amount: 65624
}
}];
}
label {
display: block;
}
.wj-flexgrid {
margin: 10px 0;
}
/* highlight the main column in the group */
.wj-flexgrid .wj-cells .wj-cell.main-column {
background: #e3f4ff;
}
/* some conditional formatting */
.big-val {
font-weight: bold;
color: darkgreen;
}
.small-val {
font-style: italic;
color: rgb(202, 0, 0);
}
/* some animation when collapsing/expanding the groups */
.wj-flexgrid.animated .wj-colheaders .wj-header.wj-cell.wj-colgroup {
transition: all .2s;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<main class="container-fluid">
<label>
Collapse/Expand Animation
<input type="checkbox" v-model="animated" />
</label>
<label>
Use cell templates
<input type="checkbox" v-model="useCellTemplates" />
</label>
<div v-bind:class="{ animated: animated }">
<wj-flex-grid headersVisibility="Column" showSelectedHeaders="All" :alternatingRowStep="0"
:showMarquee="true" :autoGenerateColumns="false" :itemsSource="data">
<wj-flex-grid-column-group binding="name" header="Name" :width="150" />
<wj-flex-grid-column-group binding="currency" header="Curr" :width="80" align="center" />
<wj-flex-grid-column-group ref="allocGr" header="Allocation" align="center" collapseTo="alloc.amount">
<wj-flex-grid-column-group binding="alloc.stock" header="Stocks" format="p0" :width="80">
<wj-flex-grid-cell-template cellType="Cell" v-if="useCellTemplates" v-slot="cell">
<span
:class="cell.row.grid.getCellData(cell.row.index, cell.col.index, false) > .2 ? 'big-val' : 'small-val'">
{{ cell.row.grid.getCellData(cell.row.index, cell.col.index, true) }}
</span>
</wj-flex-grid-cell-template>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="alloc.bond" header="Bonds" format="p0" :width="80">
<wj-flex-grid-cell-template cellType="Cell" v-if="useCellTemplates" v-slot="cell">
<span
:class="cell.row.grid.getCellData(cell.row.index, cell.col.index, false) > .2 ? 'big-val' : 'small-val'">
{{ cell.row.grid.getCellData(cell.row.index, cell.col.index, true) }}
</span>
</wj-flex-grid-cell-template>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group header="Detail" align="center">
<wj-flex-grid-column-group binding="alloc.cash" header="Cash" format="p0" :width="80">
<wj-flex-grid-cell-template cellType="Cell" v-if="useCellTemplates" v-slot="cell">
<span
:class="cell.row.grid.getCellData(cell.row.index, cell.col.index, false) > .2 ? 'big-val' : 'small-val'">
{{ cell.row.grid.getCellData(cell.row.index, cell.col.index, true) }}
</span>
</wj-flex-grid-cell-template>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="alloc.other" header="Other" format="p0" :width="80">
<wj-flex-grid-cell-template cellType="Cell" v-if="useCellTemplates" v-slot="cell">
<span
:class="cell.row.grid.getCellData(cell.row.index, cell.col.index, false) > .2 ? 'big-val' : 'small-val'">
{{ cell.row.grid.getCellData(cell.row.index, cell.col.index, true) }}
</span>
</wj-flex-grid-cell-template>
</wj-flex-grid-column-group>
</wj-flex-grid-column-group>
<wj-flex-grid-column-group binding="alloc.amount" header="Amount" format="c0" :width="100"
cssClass="main-column" />
</wj-flex-grid-column-group>
<wj-flex-grid-column-group header="Perf" align="center">
<wj-flex-grid-column-group header="Short" align="center" collapseTo="perf.ytd" :isCollapsed="true">
<wj-flex-grid-column-group binding="perf.ytd" header="YTD" format="p2" :width="100"
cssClass="main-column" />
<wj-flex-grid-column-group binding="perf.m1" header="1 M" format="p2" :width="80" />
</wj-flex-grid-column-group>
<wj-flex-grid-column-group header="Long" align="center" collapseTo="perf.m12" :isCollapsed="true">
<wj-flex-grid-column-group binding="perf.m6" header="6 M" format="p2" :width="80" />
<wj-flex-grid-column-group binding="perf.m12" header="12 M" format="p2" :width="100"
cssClass="main-column" />
</wj-flex-grid-column-group>
</wj-flex-grid-column-group>
</wj-flex-grid>
</div>
</main>
</template>
<script setup>
import "https://cdnjs.cloudflare.com/ajax/libs/flag-icon-css/3.1.0/css/flag-icon.css";
import * as DataService from "./data";
import { ref, onMounted } from "vue";
const data = ref(DataService.getData());
const animated = ref(true);
const useCellTemplates = ref(true);
const allocGr = ref(null);
// Ensure allocGr is bound correctly after the component is mounted
onMounted(() => {
if (allocGr.value && allocGr.value.control) {
allocGr.value = allocGr.value.control;
}
});
</script>
<style>
label {
display: block !important;
}
.wj-flexgrid {
margin: 10px 0;
}
/* highlight the main column in the group */
.wj-flexgrid .wj-cells .wj-cell.main-column {
background: #e3f4ff;
}
/* some conditional formatting */
.big-val {
font-weight: bold;
color: darkgreen;
}
.small-val {
font-style: italic;
color: rgb(202, 0, 0);
}
/* some animation when collapsing/expanding the groups */
.animated .wj-flexgrid .wj-colheaders .wj-header.wj-cell.wj-colgroup {
transition: all .2s;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Column Groups with Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
// get some sample data
export function getData() {
return [{
name: 'Constant Growth',
currency: 'USD',
perf: {
ytd: .0523,
m1: 0.0142,
m6: 0.0443,
m12: 0.0743
},
alloc: {
stock: 0.17,
bond: 0.32,
cash: 0.36,
other: 0.15,
amount: 23432
}
}, {
name: 'Optimus Prime',
currency: 'EUR',
perf: {
ytd: .0343,
m1: 0.043,
m6: 0.0244,
m12: 0.0543
},
alloc: {
stock: 0.61,
bond: 0.8,
cash: 0.9,
other: 0.22,
amount: 43223
}
}, {
name: 'Crypto Planet',
currency: 'BTC',
perf: {
ytd: .0343,
m1: 0.014,
m6: 0.034,
m12: 0.01243
},
alloc: {
stock: 0.1,
bond: 0,
cash: 0,
other: 0.9,
amount: 2234
}
}, {
name: 'MegaZone',
currency: 'EUR',
perf: {
ytd: .0443,
m1: 0.034,
m6: 0.0424,
m12: 0.0343
},
alloc: {
stock: 0.51,
bond: 0.9,
cash: 0.8,
other: 0.12,
amount: 32234
}
}, {
name: 'Serenity',
currency: 'YEN',
perf: {
ytd: .0522,
m1: 0.0143,
m6: 0.0458,
m12: 0.0732
},
alloc: {
stock: 0.66,
bond: 0.09,
cash: 0.19,
other: 0.06,
amount: 65624
}
}];
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import { FlexGrid, FlexGridColumnGroup, FlexGridCellTemplate } from '@mescius/wijmo.react.grid';
import './app.css';
import { data } from './data';
function App() {
const [animated, setAnimated] = useState(true);
const [useCellTemplates, setUseCellTemplates] = useState(true);
const allocGr = useRef(null);
const cellTemplate = (cell) => {
const grid = cell.row.grid;
const rowIdx = cell.row.index;
const colIdx = cell.col.index;
return (<span className={grid.getCellData(rowIdx, colIdx, false) > .2 ? 'big-val' : 'small-val'}>
{grid.getCellData(rowIdx, colIdx, true)}
</span>);
};
const animationClicked = () => setAnimated(!animated);
const templateClicked = () => setUseCellTemplates(!useCellTemplates);
const setGroupCollapsedState = (columnGroup) => {
columnGroup.isCollapsed = true;
};
const handleFlexGridInitialized = (grid) => {
let columnGroups = grid.getColumnGroups();
columnGroups.getColumn("name").width = 150;
columnGroups.getColumn("currency").width = 80;
columnGroups.getColumn("alloc.stock").width = 80;
columnGroups.getColumn("alloc.bond").width = 80;
columnGroups.getColumn("alloc.cash").width = 80;
columnGroups.getColumn("alloc.other").width = 80;
columnGroups.getColumn("alloc.amount").width = 100;
columnGroups.getColumn("perf.ytd").width = 100;
columnGroups.getColumn("perf.m1").width = 80;
columnGroups.getColumn("perf.m6").width = 80;
columnGroups.getColumn("perf.m12").width = 100;
};
return (<main className="container-fluid">
<label>
Collapse/Expand Animation
<input type="checkbox" checked={animated} onChange={animationClicked}/>
</label>
<label>
Use cell templates
<input type="checkbox" checked={useCellTemplates} onChange={templateClicked}/>
</label>
<div className={animated ? 'animated' : ''}>
<FlexGrid headersVisibility="Column" showSelectedHeaders="All" alternatingRowStep={0} showMarquee={true} autoGenerateColumns={false} itemsSource={data} initialized={handleFlexGridInitialized}>
<FlexGridColumnGroup binding="name" header="Name"/>
<FlexGridColumnGroup binding="currency" header="Curr" align="center"/>
<FlexGridColumnGroup ref={allocGr} header="Allocation" align="center" collapseTo="alloc.amount">
<FlexGridColumnGroup binding="alloc.stock" header="Stocks" format="p0">
<FlexGridCellTemplate cellType="Cell" template={useCellTemplates ? cellTemplate : null}/>
</FlexGridColumnGroup>
<FlexGridColumnGroup binding="alloc.bond" header="Bonds" format="p0">
<FlexGridCellTemplate cellType="Cell" template={useCellTemplates ? cellTemplate : null}/>
</FlexGridColumnGroup>
<FlexGridColumnGroup header="Detail" align="center">
<FlexGridColumnGroup binding="alloc.cash" header="Cash" format="p0">
<FlexGridCellTemplate cellType="Cell" template={useCellTemplates ? cellTemplate : null}/>
</FlexGridColumnGroup>
<FlexGridColumnGroup binding="alloc.other" header="Other" format="p0">
<FlexGridCellTemplate cellType="Cell" template={useCellTemplates ? cellTemplate : null}/>
</FlexGridColumnGroup>
</FlexGridColumnGroup>
<FlexGridColumnGroup binding="alloc.amount" header="Amount" format="c0" cssClass="main-column"/>
</FlexGridColumnGroup>
<FlexGridColumnGroup header="Perf" align="center">
<FlexGridColumnGroup header="Short" align="center" collapseTo="perf.ytd" initialized={setGroupCollapsedState}>
<FlexGridColumnGroup binding="perf.ytd" header="YTD" format="p2" cssClass="main-column"/>
<FlexGridColumnGroup binding="perf.m1" header="1 M" format="p2"/>
</FlexGridColumnGroup>
<FlexGridColumnGroup header="Long" align="center" collapseTo="perf.m12" initialized={setGroupCollapsedState}>
<FlexGridColumnGroup binding="perf.m6" header="6 M" format="p2"/>
<FlexGridColumnGroup binding="perf.m12" header="12 M" format="p2" cssClass="main-column"/>
</FlexGridColumnGroup>
</FlexGridColumnGroup>
</FlexGrid>
</div>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Column Groups with Templates</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
label {
display: block;
}
.wj-flexgrid {
margin: 10px 0;
}
/* highlight the main column in the group */
.wj-flexgrid .wj-cells .wj-cell.main-column {
background: #e3f4ff;
}
/* some conditional formatting */
.big-val {
font-weight: bold;
color: darkgreen;
}
.small-val {
font-style: italic;
color: rgb(202, 0, 0);
}
/* some animation when collapsing/expanding the groups */
.animated .wj-flexgrid .wj-colheaders .wj-header.wj-cell.wj-colgroup {
transition: all .2s;
}
function getData() {
return [{
name: 'Constant Growth',
currency: 'USD',
perf: {
ytd: .0523,
m1: 0.0142,
m6: 0.0443,
m12: 0.0743
},
alloc: {
stock: 0.17,
bond: 0.32,
cash: 0.36,
other: 0.15,
amount: 23432
}
}, {
name: 'Optimus Prime',
currency: 'EUR',
perf: {
ytd: .0343,
m1: 0.043,
m6: 0.0244,
m12: 0.0543
},
alloc: {
stock: 0.61,
bond: 0.8,
cash: 0.9,
other: 0.22,
amount: 43223
}
}, {
name: 'Crypto Planet',
currency: 'BTC',
perf: {
ytd: .0343,
m1: 0.014,
m6: 0.034,
m12: 0.01243
},
alloc: {
stock: 0.1,
bond: 0,
cash: 0,
other: 0.9,
amount: 2234
}
}, {
name: 'MegaZone',
currency: 'EUR',
perf: {
ytd: .0443,
m1: 0.034,
m6: 0.0424,
m12: 0.0343
},
alloc: {
stock: 0.51,
bond: 0.9,
cash: 0.8,
other: 0.12,
amount: 32234
}
}, {
name: 'Serenity',
currency: 'YEN',
perf: {
ytd: .0522,
m1: 0.0143,
m6: 0.0458,
m12: 0.0732
},
alloc: {
stock: 0.66,
bond: 0.09,
cash: 0.19,
other: 0.06,
amount: 65624
}
}];
}
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);